<?php
if (!defined("IN_MYBB"))
{
	die ("Direct access to this file is not allowed.<br />Please make use IN_MYBB is defined.");
}
function socialgroups_info()
	{

	return array(
		"name"		=> "Social Groups",
		"description"		=> "A plug-in that lets users create their own groups and control various settings.",
		"website"		=> "http://www.teamdimensional.net",
		"author"		=> "Mark Janssen",
		"authorsite"		=> "http://www.teamdimensional.net",
		"version"		=> "1.5",
		"guid" 			=> "bb3eb218959b0b48c522db1fb8e574bc",
		"compatibility"	=> "16*"
		);
	}

function socialgroups_install ()
{
	global $db, $lang, $cache;
	/* Create the necessary tables */
$lang->load("socialgroups");
	$db->query("CREATE TABLE ".TABLE_PREFIX."socialgroups (
		sgid INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
		name TEXT,
		uid INT,
		description TEXT,
		announcement TEXT,
		leader TEXT,
		privacy INT NOT NULL DEFAULT 0,
		numdisc INT,
		memberids TEXT,
		joinoptions TEXT,
		locked INT NOT NULL DEFAULT 0,
		additionalleaders TEXT)
		CHARSET = 'utf8'
		COLLATE = 'utf8_bin'
		ENGINE = MYISAM");

	$db->query("CREATE TABLE ".TABLE_PREFIX."sgconversations (
		conid INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
		topic TEXT,
		sticky INT NOT NULL DEFAULT 0,
		message TEXT,
		replies INT NOT NULL DEFAULT 0,
		lastposter TEXT,
		lastposteruid INT,
		author TEXT,
		locked INT NOT NULL DEFAULT 0,
		approved INT NOT NULL DEFAULT 1,
		puid INT,
		sgid INT,
		lastposttime BIGINT) 
		CHARSET = 'utf8'
		COLLATE = 'utf8_bin'
		ENGINE = MYISAM");

	$db->query("CREATE TABLE ".TABLE_PREFIX."sgposts (
		pid INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
		conid INT,
		uid INT,
		username TEXT,
		message TEXT,
		approved INT NOT NULL DEFAULT 1,
		time BIGINT)
		CHARSET = 'utf8'
		COLLATE = 'utf8_bin'
		ENGINE = MYISAM");

		$db->query("CREATE TABLE ".TABLE_PREFIX."socialgroupsread (
		rid INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
		uid INT,
		sgid INT,
		dateline BIGINT)
		CHARSET = 'utf8'
		COLLATE = 'utf8_bin'
		ENGINE = MYISAM");

		$db->query("CREATE TABLE ".TABLE_PREFIX."socialgroupsubscriptions (
		sid INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
		sgid INT,
		uid INT)
		CHARSET = 'utf8'
		COLLATE = 'utf8_bin'
		ENGINE = MYISAM");

		$db->query("CREATE TABLE ".TABLE_PREFIX."sgpostsubscriptions (
		sid INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
		conid INT,
		uid INT)
		CHARSET = 'utf8'
		COLLATE = 'utf8_bin'
		ENGINE = MYISAM");
		
		$db->query("CREATE TABLE ".TABLE_PREFIX."socialgrouprequests (
		rid INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
		sgid INT NOT NULL,
		uid INT NOT NULL,
		username TEXT,
		reason TEXT NOT NULL,
		approved INT NOT NULL DEFAULT 0,
		ignored INT NOT NULL DEFAULT 0)
		CHARSET = 'utf8'
		COLLATE = 'utf8_bin'
		ENGINE = MYISAM");

		$db->query("CREATE TABLE ".TABLE_PREFIX."socialgroupleaders (
		lid INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
		uid INT NOT NULL,
		sgid INT NOT NULL,
		canapprovejoins INT NOT NULL DEFAULT '1',
		caneditposts INT NOT NULL DEFAULT '1',
		candelete INT NOT NULL DEFAULT '0',
		canunapprove INT NOT NULL DEFAULT '1',
		canlockthreads INT NOT NULL DEFAULT '1',
		canaddleaders INT NOT NULL DEFAULT '0',
		canremoveleaders INT NOT NULL DEFAULT '0',
		canremovemembers INT NOT NULL DEFAULT '1')
		CHARSET = 'utf8'
		COLLATE = 'utf8_bin'
		ENGINE = MYISAM");

		/* Alter the users table to be able to track amount of posts in this area and the groups a member is in. */
	$db->query("ALTER TABLE "
		.TABLE_PREFIX."users
		ADD groupposts INT NOT NULL DEFAULT '0',
		ADD groupsin TEXT");
// Create the config group for MyBB Settings
	$query = $db->simple_select("settinggroups", "COUNT(*) as rows");
	$rows = $db->fetch_field($query, "rows");
	$new_groupconfig = array(
		'name' => 'socialgroups', 
		'title' => $lang->groups_group,
		'description' => $lang->socialgroups_info,
		'disporder' => $rows+1,
		'isdefault' => 0
	);
	
	$group['gid'] = $db->insert_query("settinggroups", $new_groupconfig);
	$new_config = array();
	
	$new_config[] = array(
		'name' => 'allow_mycode_groups',
		'title' => $db->escape_string($lang->socialgroups_mycode),
		'description' => $db->escape_string($lang->socialgroups_allow_mycode),
		'optionscode' => 'yesno',
		'value' => '1',
		'disporder' => 1,
		'gid' => $group['gid']
	);
	
	$new_config[] = array(
		'name' => 'allow_html_groups',
		'title' => $db->escape_string($lang->allow_groups_html),
		'description' => $db->escape_string($lang->allow_groups_html_info),
		'optionscode' => 'yesno',
		'value' => '0',
		'disporder' => 2,
		'gid' => $group['gid']
	);

	foreach($new_config as $array => $content)
	{
		$db->insert_query("settings", $content);
	}
	rebuild_settings();
	/* Create permission to create groups */
	$db->query("ALTER TABLE ".TABLE_PREFIX."usergroups ADD cancreatesocialgroups INT(1) NOT NULL DEFAULT '1', ADD maxgroupscreate INT(6) NOT NULL DEFAULT '5', ADD maxgroupsjoin INT(6) NOT NULL DEFAULT '5'");
	/* Make sure guests and awaiting activation can't create groups */
	$db->query("UPDATE ".TABLE_PREFIX."usergroups SET cancreatesocialgroups = '0', maxgroupscreate = '0', maxgroupsjoin ='0' WHERE gid IN(1,5,7)");
	$cache->update_usergroups();
}
function socialgroups_activate()
{
	/* Time to create the new templates */
	global $db, $mybb, $lang;
	$new_template['groups'] = '<html>
		<head>
		<title>
		Groups
		</title>
	{$headerinclude}
	</head>
	<body>
	{$header}
	{$redirect}
	<a href="{$settings[\'bburl\']}/groups.php?action=todayposts">{$lang->group_today_posts}</a> | <a href="{$settings[\'bburl\']}/groups.php?action=newposts">{$lang->group_new_posts}</a><br />
	{$groupadd}
	<table>
	{$todayposts}
	</table>
	<table>
	{$newposts}
	</table>
	<table width="100%" border="1">
	<tr>
	<th class="thead">{$lang->group_name}</th>
	<th class="thead">{$lang->group_leader}</th>
	<th class="thead">{$lang->group_discussions}</th>
	<th class="thead">{$lang->group_description}</th>
	</tr>
	{$mygroups}
	{$grouplist}
	</table>
	{$groupcreate}
	{$creategroupbutton}
	{$footer}
	</body>
	</html>';

	$new_template['grouplist'] = '<tr><td class="trow2"><a href="{$settings[\'bburl\']}/showgroup.php?gid={$group[\'sgid\']}" style="text-decoration:none">{$group[\'name\']}</td>
	<td class="trow2">{$leaderlink}</td>
	<td class="trow2">{$group[\'numdisc\']}</td>
	<td class="trow2">{$group[\'description\']}</td>
	</tr>';

	$new_template['groupthread'] = '<html>
<head>
<title>{$conversation[\'topic\']}</title>
{$headerinclude}
<script type="text/javascript">
<!--
	var quickdelete_confirm = "{$lang->quickdelete_confirm}";
// -->
</script>
<script type="text/javascript" src="jscripts/thread.js?ver=1603"></script>
</head>
<body>
	{$header}
{$edit}
	<div class="float_left">
		{$multipage}

	</div>
	<div class="float_right">
		{$newreply}
	</div>
	{$ratethread}
	<table border="0" cellspacing="{$theme[\'borderwidth\']}" cellpadding="{$theme[\'tablespace\']}" class="tborder" style="clear: both; border-bottom-width: 0;">
		<tr>
			<td class="thead" colspan="2">
				<div style="float: right;">
					<span class="smalltext"></span>
				</div>
				<div>
					<strong>{$conversation[\'topic\']}</strong>
				</div>
			</td>
		</tr>
		{$classic_header}
	</table>
	<div id="posts">
		{$groupposts}
	</div>
	<table border="0" cellspacing="{$theme[\'borderwidth\']}" cellpadding="{$theme[\'tablespace\']}" class="tborder" style="border-top-width: 0;">
		<tr>
			<td colspan="2" class="tfoot">
				{$search_thread}
				<div>
									</div>
			</td>
		</tr>
	</table>
	<div class="float_left">
		{$multipage}
	</div>
	<div style="padding-top: 4px;" class="float_right">
		{$newreply}
	</div>
	<br style="clear: both;" />
	{$groupthreadreply}
	<br />
	<div class="float_left">
		<ul class="thread_tools">
						<li class="subscription_{$add_remove_subscription}"><a href="{$settings[\'bburl\']}/groupthread.php?conid={$conid}&amp;action={$subscribe}">{$subscriptiontext}</a>
</li>
		</ul>
	</div>

	<div class="float_right" style="text-align: right;">
		{$groupthreadmodoptions}
		{$forumjump}
	</div>
	<br style="clear: both;" />
	{$usersbrowsing}
	{$footer}
</body>
</html>';

$new_template['groupthread_mod'] = '<tr>
<td class="trow2"><a href="{$settings[\'bburl\']}/groupthread.php?conid={$conid}&amp;action=edit&amp;pid={$posts[\'pid\']}"><img src="{$settings[\'bburl\']}/images/english/postbit_edit.gif" alt="{$lang->group_edit}" title="{$lang->group_edit}" /></a> 
<a href="{$settings[\'bburl\']}/groupthread.php?conid={$conid}&amp;action=delete&amp;pid={$posts[\'pid\']}"><img src="{$settings[\'bburl\']}/images/english/postbit_delete.gif" alt="{$lang->group_delete}" title="{$lang->group_delete}" /></a></td>
<td><a href="{$settings[\'bburl\']}/groupthread.php?conid={$conid}&amp;action=approve&amp;pid={$posts[\'pid\']}">{$lang->group_approve}</a> &mdash; 
<a href="{$settings[\'bburl\']}/groupthread.php?conid={$conid}&amp;action=unapprove&amp;pid={$posts[\'pid\']}">{$lang->group_unapprove}</a></td>
</tr>';

$new_template['groupthread_mod_options'] = '<form action="{$settings[\'bburl\']}/groupthread.php?conid={$conid}" method="post">
<select name="action">
<option value="unapprovethread">{$lang->groupthread_unapprove_thread}</option>
<option value="approvethread">{$lang->groupthread_approve_thread}</option>
<option value="lockthread">{$lang->groupthread_lock_thread}</option>
<option value="unlockthread">{$lang->groupthread_unlock_thread}</option>
</select>
<input type="submit" value="{$lang->group_go}" /></form>';

$new_template['groupthread_post'] = '<a name="pid{$posts[\'pid\']}" id="pid{$posts[\'pid\']}"></a>
<table border="0" cellspacing="{$theme[\'borderwidth\']}" cellpadding="{$theme[\'tablespace\']}" class="tborder" style="{$post_extra_style} {$post_visibility}" id="post_{$posts[\'pid\']}">
<tbody>
		<tr>
			<td class="tcat">
				<div class="float_left smalltext">
					{$posts[\'time\']}
				</div>
				<div style="float: right; width: auto; vertical-align: top"><span class="smalltext"><strong>{$lang->postbit_post} <a href="{$settings[\'bburl\']}/groupthread.php?conid={$conid}&amp;pid={$posts[\'pid\']}#pid{$posts[\'pid\']}">#{$posts[\'pid\']}</a></strong></span></div>
			</td>
		</tr>

		<tr>
			<td class="trow1 {$unapprovedshade}">
				<table cellspacing="0" cellpadding="0" border="0" style="width: 100%;">
					<tr>
						<td class="post_avatar" width="1" style="{$post[\'avatar_padding\']}">
							<img src="{$posts[\'avatar\']}" alt="{$posts[\'username\']}" title="{$posts[\'username\']}" />
						</td>
						<td class="post_author">
							<strong><span class="largetext">{$poster}</span></strong><br />
							<span class="smalltext">
								{$posts[\'usertitle\']}<br />
								{$post[\'userstars\']}<br />
								<img src="{$posts[\'image\']}" alt="{$posts[\'title\']}" title="{$posts[\'title\']}" />
							</span>
						</td>
						<td class="smalltext post_author_info" width="165">
							<ul style="list-style-type:none">
<li>{$lang->posts}{$posts[\'postnum\']}</li>
<li>{$lang->groupposts}{$posts[\'groupposts\']}</li>
<li>{$warninglevel}</li></ul>
						</td>
					</tr>
				</table>
			</td>
		</tr>

		<tr>
			<td class="trow2 post_content {$unapprovedshade}">
				<span class="smalltext"><strong>{$posts[\'topic\']}</strong></span>

				<div class="post_body" id="pid_{$post[\'pid\']}">
					{$posts[\'message\']}
				</div>
<hr />
								{$posts[\'signature\']}

				<div class="post_meta" id="post_meta_{$posts[\'pid\']}">
{$posts[\'iplogged\']}
								</div>
			</td>
		</tr>

		<tr>
			<td class="trow1 post_buttons {$unapprovedshade}">
				<div class="author_buttons float_left">
				<a href="{$posts[\'website\']}" target="_blank"><img src="{$theme[\'imglangdir\']}/postbit_www.gif" alt="{$lang->postbit_website}" title="{$lang->postbit_website}" /></a> <a href="private.php?action=send&amp;uid={$posts[\'uid\']}"><img src="{$theme[\'imglangdir\']}/postbit_pm.gif" alt="{$lang->postbit_pm}" title="{$lang->postbit_pm}" /></a> <a href="{$settings[\'bburl\']}/search.php?action=finduser&amp;uid={$posts[\'uid\']}"><img src="{$theme[\'imglangdir\']}/postbit_find.gif" alt="{$lang->postbit_find}" title="{$lang->postbit_find}" /></a>	
</div>
				<div class="post_management_buttons float_right">
{$groupthreadmod}
				</div>
			</td>
		</tr>
	</tbody>
</table>';

$new_template['groupthread_reply'] = '<form action="{$settings[\'bburl\']}/groupthread.php?conid={$conid}" method="post">
<input type="hidden" name="action" value="reply" />
<table border="0" cellspacing="{$theme[\'borderwidth\']}" cellpadding="{$theme[\'tablespace\']}" class="tborder">
<tr>
<td class="thead" colspan="2"><strong>{$lang->post_new_thread}</strong></td>
</tr>
<tr>
<td class="trow2" valign="top"><strong>{$lang->group_message}</strong>{$smileys}</td>
<td class="trow2">
<textarea name="message" id="message" rows="10" cols="70" tabindex="2">{$message}</textarea>
{$codebuttons}
</td>
</tr>
</table>
<input type="submit" value="{$lang->group_post_reply}" /></form>';

$new_template['groupthread_reply_error'] = '{$lang->error_no_message}';

$new_template['group_add'] = '<form action="{$settings[\'bburl\']}/groups.php" method="post">
<input type="hidden" name="action" value="newgroup" />
<table>
<tr>
<td>{$lang->group_name}:<input type="text" name="groupname" /></td>
</tr>
<tr>
<td>{$lang->group_description}:<textarea rows="3" cols="70" name="description"></textarea></td>
</tr>
<tr>
<td>{$lang->group_privacy}:<select name="privacy">
<option value="0">{$lang->anyone_read}</option>
<option value="1">{$lang->only_members_read}</option></select></td>
</tr>
<tr>
<td>{$lang->group_join_options}:<select name="joinoptions">
<option value="all">{$lang->group_all_join}</option>
<option value="approve">{$lang->group_approval_required}</option>
<option value="mod">{$lang->group_staff_only}</option></select></td>
</tr>
<tr>
<td>{$lang->announcement_prefix} <textarea name="announcement" id="message" rows="10" cols="70"></textarea>
</tr></table>
<input type="submit" value="{$lang->group_add_group}" /></form>';

$new_template['group_edit'] = '<form action="{$settings[\'bburl\']}/showgroup.php?gid={$gid}" method="post">
<input type="hidden" name="action" value="editgroup" />
<input type="hidden" name="gid" value="{$gid}" />
<table>
<tr>
<td>{$lang->group_name}:<input type="text" name="groupname" value="{$groupinfo[\'name\']}" /></td>
</tr>
<tr>
<td>{$lang->group_description}:<textarea rows="3" cols="70" name="description">{$groupinfo[\'description\']}</textarea></td>
</tr>
<tr>
<td>{$lang->group_privacy}:<select name="privacy">
{$privacy}
</select></td>
</tr>
<tr>
<td>{$lang->group_join_options}:<select name="joinoptions">
{$joinselect}
</select></td>
</tr>
<tr>
<td>{$lang->announcement_prefix} <textarea name="announcement" id="message" rows="10" cols="70">{$groupinfo[\'announcement\']}</textarea>
</td>
</tr>
</table>
<input type="submit" value="{$lang->group_edit_group}" /></form>';

$new_template['group_add_error'] = '{$lang->group_add_error}';

$new_template['group_add_success'] = '{$lang->group_add_success}';

$new_template['group_add_thread_error'] = '{$lang->group_add_thread_error}';

$new_template['group_discussions'] = '<tr>
<td class="trow2"><a href="{$settings[\'bburl\']}/groupthread.php?conid={$groupdisc[\'conid\']}" style="text-decoration:none">{$groupdisc[\'topic\']}</a></td>
<td class="trow2">{$authorlink}</td>
<td class="trow2">{$groupdisc[\'replies\']}</td>
<td class="trow2">{$lastposttime} {$lastposterlink}</td>
</tr>';

$new_template['group_display'] = '<html>
<head>
{$headerinclude}
</head>
<body>
{$header}
{$joingroup} {$leave} {$locknotice} {$approvalnotice}<br />
{$subscription} | {$updategroup} {$unapprovedrequest}<br />
{$startrequests}
{$requests}
{$endtable}
{$editgroup}
{$reason}
{$addleader}
{$redirect}
{$removemessage}
{$toomanygroups}
{$lang->forumbit_moderated_by}<br />
{$socialgroupleaders}<br /><br />
{$announcement}<br />
{$lang->group_members}:
<table border="1" width="100%">
<tr>
<th class="thead">{$lang->group_username}</th>
<th class="thead">{$lang->group_usertitle}</th>
</tr>
{$group_members}
</table>
{$groupjoin}
<table border="1" width="100%">
<tr>
<th class="thead">{$lang->group_topic}</th>
<th class="thead">{$lang->group_author}</th>
<th class="thead">{$lang->group_replies}</th>
<th class="thead">{$lang->group_last_post}</th>
</tr>
{$groupthreads}
</table>
{$newdiscussion}
{$grouptopic}
{$newthreadbutton}
{$lockswitch}
{$footer}
</body>
</html>';

$new_template['group_join_group'] = '<a href="{$settings[\'bburl\']}/showgroup.php?action=join&amp;gid={$gid}">{$lang->join_group}</a><br />';

$new_template['group_join_success'] = '{$lang->group_succesful_join} {$groupinfo[\'name\']} {$lang->group_group}.<br />';

$new_template['group_members'] = '<tr>
<td class="trow2">{$groupmemberlink}<br/>
<img src="{$groupmember[\'avatar\']}" alt="" />
{$addleaderlink} {$editleaderlink} {$removeleaderlink} {$removememberlink}
{$warninglevel}</td>
<td class="trow2">{$groupmember[\'usertitle\']}</td>
</tr>';

$new_template['group_new_discussion'] = '<form action="{$settings[\'bburl\']}/showgroup.php?gid={$gid}" method="post">
<input type="hidden" name="action" value="newtopic" />
<table border="0" cellspacing="{$theme[\'borderwidth\']}" cellpadding="{$theme[\'tablespace\']}" class="tborder">
<tr>
<td class="thead" colspan="2"><strong>{$lang->post_new_thread}</strong></td>
</tr>
<tr>
<td class="trow2" width="20%"><strong>{$lang->group_topic}</strong></td>
<td class="trow2"><input type="text" class="textbox" name="topic" size="40" maxlength="85" value="{$subject}" tabindex="1" /></td>
</tr>
<tr>
<td class="trow2" valign="top"><strong>{$lang->group_message}</strong>{$smileys}</td>
<td class="trow2">
<textarea name="message" id="message" rows="10" cols="70" tabindex="2">{$message}</textarea>
{$codebuttons}
</td>
</tr>
</table>
<input type="submit" value="{$lang->submit_thread}" /></form>';

$new_template['group_no_join'] = '<table border="0" width="100%"><tr><td>{$lang->group_unable_to_join_group}</td><td style="text-align:right"><a href="{$settings[\'bburl\']}/showgroup.php?gid={$gid}&amp;action=leavegroup">{$lang->leave_group}</a></td></tr></table><br />';

$new_template['group_no_threads'] = '<tr><td>{$lang->group_unable_to_view}.</td></tr>';

$new_tempate['groupthread_edit_post'] = '<form action="{$settings[\'bburl\']}/groupthread.php?conid={$conid}&amp;action=update&amp;pid={$pid}" method="post">
Message: <textarea name="message" rows="5" cols="50">{$grouppost[\'message\']}</textarea>
<input type="submit" value="Update"></form>';

$new_template['group_join_request'] = '<tr><td><a href="{$settings[\'bburl\']}/member.php?action=profile&amp;uid={$request[\'uid\']}">{$request[\'username\']}</a></td>
<td>{$request[\'reason\']}</td>
<td><a href="{$settings[\'bburl\']}/showgroup.php?gid={$gid}&amp;action=managerequests&amp;user={$request[\'uid\']}&amp;approve=1">{$lang->approve}</a> | <a href="{$settings[\'bburl\']}/showgroup.php?gid={$gid}&amp;action=managerequests&amp;user={$request[\'uid\']}&amp;approve=0">{$lang->deny}</a> | <a href="{$settings[\'bburl\']}/showgroup.php?gid={$gid}&amp;action=managerequests&amp;user={$request[\'uid\']}&amp;ignore=1">{$lang->ignore}</a></td></tr>';

$new_template['group_add_leader_link'] = '<br /><a href="{$settings[\'bburl\']}/showgroup.php?gid={$gid}&amp;action=addleader&amp;userid={$groupmember[\'uid\']}">{$lang->add_leader}</a>';

$new_template['group_remove_member_link'] = '<a href="{$settings[\'bburl\']}/showgroup.php?gid={$gid}&amp;action=removemember&amp;userid={$groupmember[\'uid\']}">{$lang->remove_member}</a>';

$new_template['add_new_leader'] = '<form action="{$settings[\'bburl\']}/showgroup.php?&amp;gid={$gid}" method="post">
<input type="hidden" name="userid" value="{$userid}" />
<input type="hidden" name="confirmleader" value="1" />
<input type="hidden" name="action" value="addleader" />
{$lang->can_approve_joins} <select name="canapprovejoins">
<option value="1">{$lang->yes}</option>
<option value="0">{$lang->no}</option>
</select><br />
{$lang->can_delete} <select name="candelete">
<option value="0">{$lang->no}</option>
<option value="1">{$lang->yes}</option>
</select><br />
{$lang->can_edit_posts} <select name="caneditposts">
<option value="1">{$lang->yes}</option>
<option value="0">{$lang->no}</option>
</select><br />
{$lang->can_unapprove} <select name="canunapprove">
<option value="1">{$lang->yes}</option>
<option value="0">{$lang->no}</option>
</select><br />
{$lang->can_lock_threads} <select name="canlockthreads">
<option value="1">{$lang->yes}</option>
<option value="0">{$lang->no}</option>
</select><br />
{$lang->can_add_leaders} <select name="canaddleaders">
<option value="0">{$lang->no}</option>
<option value="1">{$lang->yes}</option>
</select><br />
{$lang->can_remove_leaders} <select name="canremoveleaders">
<option value="0">{$lang->no}</option>
<option value="1">{$lang->yes}</option>
</select><br />
{$lang->can_remove_members} <select name="canremovemembers">
<option value="0">{$lang->no}</option>
<option value="1">{$lang->yes}</option>
</select>
<input type="submit" value="$lang->add_new_leader" /></form>';

$new_template['edit_leader'] = '<form action="{$settings[\'bburl\']}/showgroup.php?gid={$gid}" method="post">
<input type="hidden" name="userid" value="{$userid}" />
<input type="hidden" name="confirm" value="1" />
<input type="hidden" name="action" value="editleader" />
{$lang->can_approve_joins} <select name="canapprovejoins">
<option value="{$leader[\'canapprovejoins\']}">{$approvejoins}</option>
<option value="{$cantapprove}">{$oppositejoins}</option>
</select><br />
{$lang->can_delete} <select name="candelete">
<option value="{$leader[\'candelete\']}">{$candelete}</option>
<option value="{$cantdelete}">{$oppositedelete}</option>
</select><br />
{$lang->can_edit_posts} <select name="caneditposts">
<option value="{$leader[\'caneditposts\']}">{$caneditposts}</option>
<option value="{$canteditposts}">{$oppositeeditposts}</option>
</select><br />
{$lang->can_unapprove} <select name="canunapprove">
<option value="{$leader[\'canunapprove\']}">{$canapprove}</option>
<option value="{$cantapprove}">{$oppositeapprove}</option>
</select><br />
{$lang->can_lock_threads} <select name="canlockthreads">
<option value="{$leader[\'canlockthreads\']}">{$canlock}</option>
<option value="{$cantlock}">{$oppositelock}</option>
</select><br />
{$lang->can_add_leaders} <select name="canaddleaders">
<option value="{$leader[\'canaddleaders\']}">{$addleaders}</option>
<option value="{$cantaddleaders}">{$oppositeaddleaders}</option>
</select><br />
{$lang->can_remove_leaders} <select name="canremoveleaders">
<option value="{$leader[\'canremoveleaders\']}">{$removeleaders}</option>
<option value="{$cantremoveleaders}">{$oppositeremoveleaders}</option>
</select><br />
{$lang->can_remove_members} <select name="canremovemembers">
<option value="{$leader[\'canremovemembers\']}">{$removemembers}</option>
<option value="{$cantremovemembers}">{$oppositeremovemembers}</option>
</select><br />
<input type="submit" value="{$lang->update}" /></form>';

$new_template['group_edit_leader_link'] = '<a href="{$settings[\'bburl\']}/showgroup.php?gid={$gid}&amp;action=editleader&amp;userid={$groupmember[\'uid\']}">{$lang->edit_leader}</a>';

$new_template['group_remove_leader_link'] = '<a href="{$settings[\'bburl\']}/showgroup.php?gid={$gid}&amp;action=removeleader&amp;userid={$groupmember[\'uid\']}">{$lang->remove_leader}</a>';

$new_template['socialgroup_leader'] = '{$leaderlink}{$comma}';

$new_template['socialgroupupgrade_form'] = '<form action="{$settings[\'bburl\']}/socialgroupsupgrade.php" method="post">
{$lang->previous_version}: <select name="version">
<option value="1.4" selected="selected">1.4</option>
</select><br />
<input type="submit" value="{$lang->go}" /></form>';

$new_template['socialgroupupgrade'] = '<html>
<head>
<title>Upgrade</title>
{$headerinclude}
</head>
<body>
{$header}
{$complete}
{$upgradeform}
{$footer}
</body>
</html>';

foreach($new_template as $title => $template)
	{
		$new_template = array('title' => $db->escape_string($title), 'template' => $db->escape_string($template), 'sid' => '-1', 'version' => '1600', 'dateline' => TIME_NOW);
		$db->insert_query('templates', $new_template);
	}
require MYBB_ROOT."/inc/adminfunctions_templates.php";
find_replace_templatesets("header_welcomeblock_member", "#".preg_quote("{\$lang->welcome_usercp}")."#i", "{\$lang->welcome_usercp}</a> &mdash; <a href=\"{\$settings['bburl']}/groups.php\">{\$lang->groups_group}</a>");
}

function socialgroups_deactivate()
{
	/* Get rid of the templates */
	global $db, $mybb;
	$delete_templates = array ('grouplist', 'groups', 'groupthread', 'groupthread_mod', 'groupthread_mod_options', 'groupthread_post', 'groupthread_reply', 'groupthread_reply_error', 
		'group_add', 'group_edit', 'group_add_error', 'group_add_success', 'group_add_thread_error', 'group_discussions', 'group_display', 'group_join_group', 'group_join_success', 
		'group_members', 'group_new_discussion', 'group_no_join', 'group_no_threads', 'group_join_request', 'group_add_leader_link', 'group_remove_member_link', 'add_new_leader',
		'group_edit_leader_link', 'edit_leader', 'group_remove_leader_link,', 'socialgroup_leader', 'socialgroupupgrade_form', 'socialgroupupgrade');
	foreach($delete_templates as $template)
	{
		$db->delete_query('templates', "title = '{$template}'");
	}
	require MYBB_ROOT."/inc/adminfunctions_templates.php";
	find_replace_templatesets("header_welcomeblock_member", "#".preg_quote("{\$lang->welcome_usercp}</a> &mdash; <a href=\"{\$settings['bburl']}/groups.php\">{\$lang->groups_group}</a>")."#i", "{\$lang->welcome_usercp} </a>");
}

function socialgroups_uninstall()
{
	/* We are uninstalling the groups application so we must alter the tables again.*/
	global $db, $cache;
	$db->query("DROP TABLE ".TABLE_PREFIX."socialgroups");
	$db->query("DROP TABLE ".TABLE_PREFIX."sgconversations");
	$db->query("DROP TABLE ".TABLE_PREFIX."sgposts");
	$db->query("DROP TABLE ".TABLE_PREFIX."socialgroupsread");
	$db->query("DROP TABLE ".TABLE_PREFIX."socialgroupsubscriptions");
	$db->query("DROP TABLE ".TABLE_PREFIX."sgpostsubscriptions");
	$db->query("DROP TABLE ".TABLE_PREFIX."socialgrouprequests");
	$db->query("DROP TABLE ".TABLE_PREFIX."socialgroupleaders");
	$db->query("ALTER TABLE ".TABLE_PREFIX."users
		DROP groupposts, DROP groupsin");
	$db->query("ALTER TABLE ".TABLE_PREFIX."usergroups DROP cancreatesocialgroups, DROP maxgroupscreate, DROP maxgroupsjoin");
		$query = $db->simple_select('settinggroups', 'gid', 'name = "socialgroups"');
	$groupid = $db->fetch_field($query, 'gid');
	$db->delete_query('settings','gid = "'.$groupid.'"');
	$db->delete_query('settinggroups','gid = "'.$groupid.'"');
	rebuild_settings();
	$cache->update_usergroups();
}

function socialgroups_is_installed()
{
	global $db;
	/* Is the plug in already installed? */
	if ($db->table_exists("socialgroups"))
	{
		return true;
	}
	return false;
}
$plugins->add_hook("global_start", "socialgroups_load_language");
$plugins->add_hook("admin_formcontainer_end", "socialgroups_edit_group");
$plugins->add_hook("admin_user_groups_edit_commit", "socialgroups_edit_group_do");

function socialgroups_load_language()
{
	global $lang;
	$lang->load("socialgroups");
}

function socialgroups_edit_group()
{
	global $run_module, $form_container, $lang, $form, $mybb;
	if($run_module == 'user' && !empty($form_container->_title) & !empty($lang->users_permissions) & $form_container->_title == $lang->users_permissions)
	{
		// Load the language
		$lang->load('socialgroups');
		$socialgroups_options = array();
		$socialgroups_options[] = $form->generate_check_box('cancreatesocialgroups', 1, $lang->can_create_social_groups, array('checked' => $mybb->input['cancreatesocialgroups']));
		$form_container->output_row($lang->social_groups, '', '<div class="group_settings_bit">'.implode('</div><div class="group_settings_bit">', $socialgroups_options).'</div>');
		$form_container->output_row('', $lang->max_groups_create, $form->generate_text_box('maxgroupscreate', $mybb->input['maxgroupscreate'], array('id' => 'maxgroupscreate')), 'maxgroupscreate');
		$form_container->output_row('', $lang->max_groups_join, $form->generate_text_box('maxgroupsjoin', $mybb->input['maxgroupsjoin'], array('id' => 'maxgroupsjoin')), 'maxgroupsjoin');
	}
}

function socialgroups_edit_group_do()
{
	global $updated_group, $mybb;
	$updated_group['cancreatesocialgroups'] = $mybb->input['cancreatesocialgroups'];
	$updated_group['maxgroupscreate'] = intval($mybb->input['maxgroupscreate']);
	$updated_group['maxgroupsjoin'] = intval ($mybb->input['maxgroupsjoin']);
}

?>